program master;
{ Mastermind by uja }
uses crt,graph,BGIFont,intuit,drivers;

const titel='* * *   U J A ''s   M a s t e r m i n d    * * *    V.0.99   -   TP6   -';
      imafil='mastern.ima'; tmax=8; fmax=8;
      ox=-16; dx=56; oy=56; dy=36;

type ivector=array[1..8] of integer;

var ok,neu,ende,geschafft,lang:boolean;
    xy1,xy2                   :Koords;
    ibord1,ibord2             :array[1..2] of Border;
    itext1,itext2             :array[1..8] of IntuiText;
    ima                       :array[1..8] of Image;
    igad                      :array[1..6] of Gadget;

    i,mx,my,alt,akt,nfarben,ncodes,versuch:integer;
    f,f0                          :ivector;
    ngames,ngewonnen,npunkte      :longint;
    ch:char;

{ ----------------------------------------------------------------------- }
{$i master1a.inc }  { liefert: }
{ procedure imagesholen;    }
{ procedure screenfarben;   }
{ procedure initstructures; }
{ procedure zeichnescreen(nfarben,ncodes);  }
{ ------------------------------------------------------------------------ }
{$i master2.inc }  { liefert: }
{ markierestein(var alt,neu:integer); }
{ anzeige(versuch,korrekteFarben,korrekteCodes:integer); }
{ initgame(var nfarben,ncodes,alt,akt:integer;
                   var f,f0:ivector;
                   var versuch:integer;
                   var geschafft,neu:boolean);
{ --------------------------------------------------------------------- }


procedure auswerten(nfarben,ncodes:integer; f,f0:ivector;
                    var cf,cc:integer);
var i,j    :integer;
    h,h0   :ivector;
begin
{ Farbhufigkeit bestimmen: }
   for i:=1 to nfarben do h[i]:=0;
   h0:=h;
   for j:=1 to nfarben do for i:=1 to ncodes do begin
      if f[i]=j then inc(h[j]);
      if f0[i]=j then inc(h0[j]);
   end;

{ korrekte Farben: Schnittmenge: }
   cf:=0;
   for i:=1 to nfarben do if h[i]<h0[i] then cf:=cf+h[i] else cf:=cf+h0[i];

{ korrekter Code: }
   cc:=0;
   for i:=1 to ncodes do if f[i]=f0[i] then inc(cc);
end;




procedure gadgetauswertung(lang:boolean; g:integer;
                           var nfarben,ncodes,versuch,alt,akt:integer;
                           var f,f0:ivector; var neu,ende,geschafft:boolean);
var i,posi,ncol,ncod:integer;
    voll            :boolean;
begin
case g of
   1: begin
          if mx<igad[g].x+igad[g].width div 2 then begin
             if nfarben<8 then inc(nfarben);
          end else begin
             if nfarben>4 then dec(nfarben);
          end;
          neu:=true;
       end;

   2:  begin
          if mx<igad[g].x+igad[g].width div 2 then begin
             if ncodes<8 then inc(ncodes);
          end else begin
             if ncodes>4 then dec(ncodes);
          end;
          neu:=true;
       end;

   3: neu:=true;
   4: ende:=true;
   5: if lang then begin
         akt:=(mx-ox-4) div dx;
         if akt<1 then akt:=1;
         if akt>nfarben then akt:=nfarben;
         markierestein(alt,akt);
      end;
   6: if lang then if akt >0 then begin
         posi:=(mx-ox-4) div dx;
         if posi<1 then posi:=1;
         if posi>ncodes then posi:=ncodes;
         DrawImage(posi*dx+ox+4,versuch*dy+oy,addr(ima[akt]));
         f[posi]:=akt;
         voll:=true;
         for i:=1 to ncodes do if f[i]=0 then voll:=false;
         if voll then begin
            inc(versuch);
            auswerten(nfarben,ncodes,f,f0,ncol,ncod);
            anzeige(versuch,ncol,ncod);
            geschafft:=ncod=ncodes;
            for i:=1 to ncodes do f[i]:=0;
         end;
      end;
   end;
end;


procedure enderoutine(nrunden,ngew,npkt:longint;
                      geschafft:boolean);
var temp,t1,t2,t3:string;
    bc           :integer;
begin
   str(nrunden:3,t1);
   str(ngew   :3,t2);
   str(npkt   :8,t3);
   if geschafft then begin
      temp:='Decodierung erfolgreich!';
      setcolor(3);
      bc:=4;
   end else begin
      temp:='Dekodierung nicht geglckt!';
      setcolor(0);
      bc:=9;
   end;

   RectFill(70,98,585,317,0);
   RectFill(62,90,577,309,0);
   RectFill(63,91,576,308,1);
   RectFill(64,92,575,307,bc);
   SetTextStyle(gothicfont,horizdir,5);
   outtextxy(80,120,temp);
   SetTextStyle(gothicfont,horizdir,2);
   temp:='Von'+t1+' Runden wurden'+t2+' gewonnen';
   outtextxy(80,200,temp);
   temp:='mit insgesamt'+t3+' Punkten';
   outtextxy(160,256,temp);

   SetTextStyle(defaultfont,horizdir,1);
end;

{ ------------------------------------------------------------------------ }

begin
   initscreen(ok);
   if ok then begin
      imagesholen;
      initstructures;
      screenfarben;
      nfarben:=6;
      ncodes:=4;
      ngames:=0;
      ngewonnen:=0;
      npunkte:=0;


      while not ende do begin
       initgame(nfarben,ncodes,alt,akt,f,f0,versuch,geschafft,neu);
       lang:=true;
       repeat
          if geschafft or (versuch>10) then begin
             inc(ngames);
             if geschafft then inc(ngewonnen);
             npunkte:=npunkte+(11-versuch)*(nfarben*ncodes);
             enderoutine(ngames,ngewonnen,npunkte,geschafft);
             versuch:=1;
             geschafft:=false;
             lang:=false;
          end;
          showmouse;
          delay(50);
          getgadget(addr(igad[1]),i,mx,my);
          hidemouse;
          if i>0 then gadgetauswertung
                     (lang,i,nfarben,ncodes,versuch,alt,akt,f,f0,
                                               neu,ende,geschafft);
         if keypressed then ende:=ende or (readkey=#27);
      until ende or neu;

      end;
      textmode(3)
   end;
end.


